'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _babelCore = require('babel-core');

var _s2sHelperGetPluginName = require('s2s-helper-get-plugin-name');

// eslint-disable-next-line flowtype/no-weak-types
exports.default = (code, { eventPath, plugin, filename }) => {
  if (!plugin || !plugin.plugin) {
    throw new Error('required plugin');
  }

  const opts = plugin.plugin;
  const fromOpts = { from: eventPath };

  const lastPlugin = Array.isArray(opts) ? [opts[0], _extends({}, opts[1], fromOpts)] : [opts, fromOpts];

  const { code: result } = (0, _babelCore.transform)(code, {
    filename,
    babelrc: false,
    plugins: [lastPlugin],
    parserOpts: {
      plugins: ['jsx', 'flow', 'objectRestSpread', 'classProperties']
    }
  });

  return {
    code: result ? result.trim() : '',
    meta: {
      handlerName: 'babel',
      pluginName: (0, _s2sHelperGetPluginName.getPluginName)(lastPlugin[0])
    }
  };
};